<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from parguide.texi on 28 April 1999 -->

<TITLE>The SUIF Parallelizing Compiler Guide - Compiling Parallel Programs</TITLE>
<link href="parguide_3.html" rel=Next>
<link href="parguide_1.html" rel=Previous>
<link href="parguide_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_1.html">previous</A>, <A HREF="parguide_3.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC2" HREF="parguide_toc.html#TOC2">Compiling Parallel Programs</A></H1>

<P>
To invoke the parallelization phases of the SUIF compiler, 
<CODE>-parallel</CODE> flag of the compiler driver <TT>`pscc'</TT>. 
The passes that <TT>`pscc'</TT> runs for parallelization are as follows:

</P>
<DL COMPACT>

<DT>Constant Propagation (<TT>`porky -const-prop'</TT>).
<DD>
Propagate the values of constants.   

<DT>Scalarize Array Accesses (<TT>`porky -scalarize'</TT>).
<DD>
Turn local array variables into collections of element variables
when all uses of the array are loads or stores of known elements.

<DT>Forward Propagation (<TT>`porky -forward-prop'</TT>).
<DD>
Propagate the calculation of local variables into the
bound and step expressions of TREE_FORs and the index expressions of
array reference instructions when possible.  

<DT>Normalization (<TT>`predep -normalize'</TT>).
<DD>
Normalize all TREE_FORs by modifying
all array references and loop definitions so that the step 
is always 1 and the test is always less-than-or-equal.

<DT>Induction Variable Detection (<TT>`porky -ivar'</TT>, <TT>`porky -know-bounds'</TT>).
<DD>
Recognize auxiliary induction variables and replace the uses within
loops by expressions of the loop index.  The closed form for the value
is assigned to the auxiliary induction variables outside the loop.

<DT>Constant Folding (<TT>`porky -fold'</TT>).
<DD>
Fold constants in expressions.

<DT>Scalar Privatization Analysis (<TT>`moo -Psce'</TT>).
<DD>
Find privatizable scalar variables within each loop.  
A variable is privatizable if every iteration of the loop
can have its own copy of the variable.

<DT>Reduction Recognition (<TT>`reduction'</TT>).
<DD>
Recognize reductions in loops.  A reduction is an associative
computation accumulated into one location.  Such loops can then be 
parallelized with simple synchronization.

<DT>Dependence Preprocessing (<TT>`predep -presc'</TT>)
<DD>
Preprocess for dependence analysis of simple non-linear array access
functions.
Since the SUIF dependence analyzer is a linear affine expression based 
analyzer, it cannot handle any non-linear array access functions. 
This pass preprocesses the code for the case where symbolic 
coefficients are used in array access functions.

<DT>Parallelism and Locality Optimizer (<TT>`skweel -T'</TT>)
<DD>
Analyze and transform the code to optimize loop-level parallelism
and locality.  
This pass performs data dependence analysis using the <TT>`dependence'</TT>
library.  It uses unimodular loop transformations (such as loop interchange,
reversal and skewing) to expose coarse-grain parallelism in the code.

<DT>Parallel Code Generator (<TT>`pgen'</TT>).
<DD>
Generate parallel code for shared address space multiprocessors.
This pass restructures the SUIF code and inserts calls to the 
parallel run-time library.  
</DL>

<P>
After running the parallelization passes, <TT>`pscc'</TT> can generate
<CODE>C</CODE> code or MIPS code.  The current default is for <TT>`pscc'</TT> to run
the MIPS code generator.  To run the SUIF-to-C converter, 
use the <CODE>-s2c</CODE> flag with <TT>`pscc'</TT>.
For example, to run the parallelizer on a FORTRAN source file
and then generate a C output file, use the command:

</P>

<PRE>
        pscc -parallel -s2c -.out.c myprog.f
</PRE>

<P>
This tells <TT>`pscc'</TT> to run the parallelization passes, followed by 
<TT>`s2c'</TT>.  The resulting C program is in the file <CODE>myprog.out.c</CODE>.

</P>
<P>
Any programs that are run through the parallel code generator
<CODE>pgen</CODE> must link in the run-time library for the target machine.
The run-time libraries for SGI and DASH machines are <TT>`runtime_sgi'</TT>
and <TT>`runtime_dash'</TT>, respectively.  The uniprocessor library is
called <TT>`runtime_seq'</TT>.  In addition, FORTRAN programs must link in
the <TT>`F77_doall'</TT> library.  The <TT>`F77_doall'</TT> library replaces the
<TT>`F77'</TT> library used for sequential FORTRAN programs.  These
libraries are linked in automatically by <TT>`pscc'</TT>.  For example, to
generate a parallel executable on an SGI machine starting from the
original FORTRAN source use the command:

</P>

<PRE>
        pscc -parallel -o myprog myprog.f
</PRE>

<P>
Or, to compile the C file <CODE>myprog.out.c</CODE> generated by <TT>`s2c'</TT> above:

</P>

<PRE>
        cc -o myprog myprog.out.c \
            $(SUIFHOME)/$(MACHINE)/lib/libruntime_sgi.a \
            $(SUIFHOME)/$(MACHINE)/lib/libF77_doall.a \
            $(SUIFHOME)/$(MACHINE)/lib/libI77.a -lm -lmpc
</PRE>

<P>
where <CODE>-lm</CODE> and <CODE>-lmpc</CODE> are the math library and SGI
multiprocessing library, respectively.

</P>
<P><HR><P>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_1.html">previous</A>, <A HREF="parguide_3.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
</BODY>
</HTML>
